## ntpsec 1.1.8+dfsg1

=== wscript ===
from __future__ import print_function

from datetime import datetime
import itertools
import os
import shlex
import sys
import time

from waflib import Build
from waflib import Context
from waflib import Scripting
from waflib import Utils
from waflib.Build import (BuildContext, CleanContext, InstallContext,
                          StepContext, ListContext)
from waflib.Context import BOTH
from waflib.Errors import WafError
from waflib.Logs import pprint
from waflib.Tools import waf_unit_test

# Avoid writing .pyc files in wafhelpers/
sys.dont_write_bytecode = True

from wafhelpers.options import options_cmd
from wafhelpers.probes import probe_header, probe_function
from wafhelpers.test import test_write_log, test_print_log


pprint.__doc__ = None

APPNAME='ntpsec'

out = "build"

config = {
    "out": out,
    "OPT_STORE": {}
}


def help(ctx):
    "Be helpful, give a usage"
    print('''
Usage: waf <command>
    build       Build the project
    check       Run tests
    configure   Configure the project
    dist        Create a release
    install     Install the project
    loccount    Show SLOC count of the source tree
    uninstall   Uninstall the project

''')


def options(ctx):
    options_cmd(ctx, config)
    ctx.recurse("pylib")


def configure(ctx):
    class oc(Build.BuildContext):
        cmd = 'oc'

        def exec_command(self, cmd, **kw):
            kw['output'] = BOTH
            try:
                err, out = self.cmd_and_log(cmd, **kw)
            except WafError as e:
                self.logger.debug('WafError')
                return e.returncode
            if (len(out) and any(word in out for word
                                 in ['err', 'err:', 'error', 'error:',
                                     'ignored', 'illegal', 'unknown',
                                     'unrecognized', 'warning'])):
                self.logger.debug('noooo %r' % out)
                return 1
            if err:
                self.logger.debug('noooo %r' % err)
                return 1
            return 0

    def msg(str):
        pprint("YELLOW", str)

    def msg_setting(name, val):
        pprint("NORMAL", "  %-30s: " % name, sep="")
        pprint("YELLOW", val)

    srcnode = ctx.srcnode.abspath()
    bldnode = ctx.bldnode.abspath()

    ctx.run_build_cls = 'check'
    ctx.load('waf', tooldir='wafhelpers/')
    ctx.load('waf_unit_test')
    ctx.load('pytest')
    ctx.load('gnu_dirs')

    with open("VERSION", "r") as f:
        ntpsec_release = f.read().split(" ")[0].strip()

    ctx.env.OPT_STORE = config["OPT_STORE"]

    opt_map = {}
    # Wipe out and override flags with those from the commandline
    for flag in ctx.env.OPT_STORE:
        if flag == "--undefine":
            for sym in ctx.env.OPT_STORE[flag]:
                ctx.undefine(sym)
        elif flag == "--define":
            for symval in ctx.env.OPT_STORE[flag]:
                (sym, val) = symval.split("=")
                try:
                    ctx.define(sym, int(val))
                except ValueError:
                    ctx.define(sym, val)
        else:
            opt = flag.replace("--", "").upper()
            opt_map[opt] = ctx.env.OPT_STORE[flag]

    msg("--- Configuring host ---")
    ctx.setenv('host', ctx.env.derive())

    ctx.load('compiler_c')
    ctx.start_msg('Checking compiler version')
    ctx.end_msg("%s" % ".".join(ctx.env.CC_VERSION))
    # Ensure m4 is present, or bison will fail with SIGPIPE
    ctx.find_program('m4')
    ctx.load('bison')

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.enable_rtems_trace:
        ctx.find_program("rtems-tld", var="BIN_RTEMS_TLD",
                         path_list=[ctx.options.rtems_trace_path,
                                    '${BINDIR}'])
        ctx.env.RTEMS_TEST_ENABLE = True
        ctx.env.RTEMS_TEST_FLAGS = [
            "-C", "%s/devel/trace/ntpsec-trace.ini" % srcnode,
            "-W", "%s/ntpsec-wrapper" % bldnode,
            "-P", "%s/devel/trace/" % srcnode,
            "-f", "-I%s" % bldnode,
            "-f", "-I%s/include/" % srcnode,
        ]

    # Not needed to build.  Used by utility scripts.
    ctx.find_program("awk", var="BIN_AWK", mandatory=False)
    ctx.find_program("sh", var="BIN_SH", mandatory=False)

    # used to make man and html pages
    ctx.find_program("asciidoc", var="BIN_ASCIIDOC", mandatory=False)
    # make sure asciidoc is new enough.
    # based on check_python_version() from waf
    if ctx.env.BIN_ASCIIDOC:
        # https://lists.ntpsec.org/pipermail/devel/2016-July/001778.html
        asciidocminver = (8, 6, 0)
        # Get asciidoc version string
        cmd = ctx.env.BIN_ASCIIDOC + ['--version']
        # example output: asciidoc 8.6.9
        lines = ctx.cmd_and_log(cmd).split()[1].split(".")
        assert len(lines) == 3, "found %r lines, expected 3: %r" \
            % (len(lines), lines)
        asciidocver_tuple = (int(lines[0]), int(lines[1]), int(lines[2]))

        # Compare asciidoc version with the minimum required
        result = (asciidocver_tuple >= asciidocminver)

        asciidocver_full = '.'.join(map(str, asciidocver_tuple[:3]))
        asciidocminver_str = '.'.join(map(str, asciidocminver))
        ctx.msg('Checking for asciidoc version >= %s' % (asciidocminver_str,),
                asciidocver_full, color=result and 'GREEN' or 'YELLOW')

        if not result:
            del ctx.env.BIN_ASCIIDOC
    ctx.find_program("a2x", var="BIN_A2X", mandatory=False)
    ctx.find_program("xsltproc", var="BIN_XSLTPROC", mandatory=False)

    ctx.env.ENABLE_DOC = False
    if ctx.env.BIN_ASCIIDOC and ctx.env.BIN_XSLTPROC and ctx.env.BIN_A2X:
        ctx.env.ENABLE_DOC = True

    if ctx.options.enable_doc and not ctx.env.ENABLE_DOC:
        ctx.fatal("asciidoc and xsltproc are required in order "
                  "to build documentation")
    elif ctx.options.enable_doc:
        ctx.env.ASCIIDOC_FLAGS = []
        ctx.env.ENABLE_DOC_USER = ctx.options.enable_doc

    # XXX: conditionally build this with --disable-man?
    # Should it build without docs enabled?
    ctx.env.A2X_FLAGS = ["--format", "manpage"]
    if not ctx.options.enable_a2x_xmllint:
        ctx.env.A2X_FLAGS += ["--no-xmllint"]

    # Disable manpages within build()
    if ctx.options.disable_manpage:
        ctx.env.DISABLE_MANPAGE = True

    ctx.check_cfg(
        package='systemd', variables=['systemdsystemunitdir'],
        uselib_store='SYSTEMD', mandatory=False,
        msg="Checking for systemd")
    if ctx.env.SYSTEMD_systemdsystemunitdir:
        ctx.start_msg("systemd unit directory:")
        ctx.end_msg(ctx.env.SYSTEMD_systemdsystemunitdir)

    source_date_epoch = os.getenv('SOURCE_DATE_EPOCH', None)
    if ctx.options.build_epoch is not None:
        build_epoch = ctx.options.build_epoch
        ctx.define("BUILD_EPOCH", build_epoch, comment="Using --build-epoch")
    elif source_date_epoch:
        if not source_date_epoch.isdigit():
            ctx.fatal("ERROR: malformed SOURCE_DATE_EPOCH")
        build_epoch = int(source_date_epoch)
        ctx.define("BUILD_EPOCH", build_epoch, comment="Using SOURCE_DATE_EPOCH")
    else:
        build_epoch = int(time.time())
        ctx.define("BUILD_EPOCH", build_epoch, comment="Using default")

    build_epoch_formatted = datetime.utcfromtimestamp(build_epoch).strftime("%Y-%m-%dT%H:%M:%SZ")
    if ((os.path.exists(".git") and
            ctx.find_program("git", var="BIN_GIT", mandatory=False))):
        cmd = ctx.env.BIN_GIT + shlex.split("log -1 --format=%h")
        git_short_hash = ctx.cmd_and_log(cmd).strip()

        ctx.env.NTPSEC_VERSION = "%s+" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = "%s+ %s (git rev %s)" % (ntpsec_release, build_epoch_formatted, git_short_hash)
    else:
        ctx.env.NTPSEC_VERSION = "%s" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = "%s %s" % (ntpsec_release, build_epoch_formatted)
    ctx.define("NTPSEC_VERSION", ctx.env.NTPSEC_VERSION)
    ctx.define("NTPSEC_VERSION_EXTENDED", ctx.env.NTPSEC_VERSION_EXTENDED)

    # We require some things that C99 doesn't enable, like pthreads.
    # These flags get propagated to both the host and main parts of the build.
    #
    # _POSIX_C_SOURCE
    #      If ==1, like _POSIX_SOURCE;
    #      if >=2 add IEEE Std 1003.2;
    #      if >=199309L, add IEEE Std 1003.1b-1993;
    #      if >=199506L, add IEEE Std 1003.1c-1995;
    #      if >=200112L, all of IEEE 1003.1-2004
    #      if >=200809L, all of IEEE 1003.1-2008
    #
    # FIXME: We'd like this to be -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700
    # rather than -D_GNU_SOURCE, but that runs into problems in two places:
    # (1) The ISC net handling stuff, where struct in6_addr’ loses a member
    # named s6_addr32 that the macros need, and (2) three BSD functions
    # related to chroot jailing in the sandbox code.
    #
    # Note that _POSIX_C_SOURCE >= 199506L and _GNU_SOURCE both turn on
    # _POSIX_PTHREAD_SEMANTICS and _REENTRANT
    #
    ctx.env.CFLAGS = ["-std=c99", "-D_GNU_SOURCE"] + ctx.env.CFLAGS

    msg("--- Configuring main ---")
    ctx.setenv("main", ctx.env.derive())

    from wafhelpers.check_sizeof import check_sizeof

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.cross_compiler:
        ctx.env.ENABLE_CROSS = True

        ctx.start_msg("Using Cross compiler CC:")
#           ctx.get_cc_version(ctx.env.CC, gcc=True)
        ctx.end_msg(ctx.options.cross_compiler)

        ctx.env.CC = shlex.split(ctx.options.cross_compiler)
        ctx.env.LINK_CC = shlex.split(ctx.options.cross_compiler)

        if ctx.env["CROSS-CFLAGS"]:
            # Lexically split each part of the CFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-CFLAGS"]]
            ctx.env.CFLAGS = list(itertools.chain.from_iterable(iter))

        if ctx.env["CROSS-LDFLAGS"]:
            # Lexically split each part of the LDFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-LDFLAGS"]]
            ctx.env.LDFLAGS = list(itertools.chain.from_iterable(iter))

    if ctx.options.list:
        from wafhelpers.refclock import refclock_map
        print("ID    Description")
        print("~~    ~~~~~~~~~~~")
        for id in refclock_map:
            print("%-5s %s" % (id, refclock_map[id]["descr"]))

        return

    # These are required by various refclocks
    # needs to be tested before CFLAGS are set
    if ctx.check_endianness() == "big":
        ctx.define("WORDS_BIGENDIAN", 1)

    if ctx.options.enable_leap_testing:
        ctx.define("ENABLE_LEAP_TESTING", 1,
                   comment="Enable leap seconds on other than 1st of month.")

    # check for some libs first.  some options, like stack protector,
    # may depend on some libs, like -lssp
    ctx.check_cc(lib="m", comment="Math library")
    ctx.check_cc(lib="rt", mandatory=False, comment="realtime library")
    ctx.check_cc(lib="pthread", mandatory=False, comment="threads library")
    ctx.check_cc(lib="execinfo", mandatory=False,
                 comment="BSD backtrace library")
    ret = ctx.check_cc(lib="bsd", mandatory=False,
                       comment="BSD compatibility library")
    if ret:
        ctx.env.LDFLAGS += ["-lbsd"]

    # -lssp and -lssp_nonshared may be needed by older gcc to
    # support "-fstack-protector-all"
    ret = ctx.check_cc(lib="ssp", mandatory=False,
                       comment="libssp")
    if ret:
        ctx.env.LDFLAGS += ["-lssp"]

    ret = ctx.check_cc(lib="ssp_nonshared", mandatory=False,
                       comment="libssp_nonshared")
    if ret:
        ctx.env.LDFLAGS += ["-lssp_nonshared"]

    cc_test_flags = [
        ('f_stack_protector_all', '-fstack-protector-all'),
        ('PIC', '-fPIC'),
        ('PIE', '-pie -fPIE'),
        # this quiets most of macOS warnings on -fpie
        ('unused', '-Qunused-arguments'),

=== attic/wscript ===
def build(ctx):
    util = ['sht', 'digest-find', 'digest-timing', 'clocks', 'backwards']

    for name in util:
        ctx(
            target=name,
            features="c cprogram",
            includes=[ctx.bldnode.parent.abspath(), "../include"],
            source=[name + ".c"],
            use="ntp M CRYPTO RT PTHREAD",
            install_path=None,
        )

=== etc/wscript ===
def build(ctx):

    units = [
        "ntp-wait.service",
        "ntpd.service",
        "ntpviz-daily.service",
        "ntplogtemp.service",
        "ntplogtemp.timer",
        "ntpviz-daily.timer",
        "ntpviz-weekly.service",
        "ntpviz-weekly.timer",
    ]

    # Install unit files
    ctx(
        features="subst",
        source=units,
        target=units,
        install_path=ctx.env.SYSTEMD_systemdsystemunitdir,
    )

=== libaes_siv/wscript ===
def build(ctx):
    # libaes_siv has warnings when built with -Wshadow, so make sure to use
    # -Wno-shadow
    ctx.env.CFLAGS_cstlib = ['-Wno-shadow']

    ctx(
        target="aes_siv",
        features="c cstlib",
        includes=[ctx.bldnode.parent.abspath()],
        source="aes_siv.c",
        use="CRYPTO",
    )

=== libntp/wscript ===
def build(ctx):

    libntp_source = [
        "authkeys.c",
        "authreadkeys.c",
        "clocktime.c",
        "decodenetnum.c",
        "dolfptoa.c",
        "getopt.c",
        "initnetwork.c",
        "isc_interfaceiter.c",
        "isc_net.c",
        "macencrypt.c",
        "ntp_endian.c",
        "numtoa.c",
        "refidsmear.c",
        "socket.c",
        "socktoa.c",
        "ssl_init.c",
        "syssignal.c",
    ]

    libntp_source_sharable = [
        "assert.c",
        "clockwork.c",
        "emalloc.c",
        "hextolfp.c",
        "lib_strbuf.c",
        "msyslog.c",
        "ntp_calendar.c",
        "ntp_random.c",
        "prettydate.c",
        "statestr.c",
        "systime.c",
        "timespecops.c",
    ]

    if not ctx.env.HAVE_STRLCAT or not ctx.env.HAVE_STRLCPY:
        libntp_source_sharable += ["strl_obsd.c"]

    # C library
    ctx(
        features="c cstlib",
        includes=[ctx.bldnode.parent.abspath(), "../include"],
        source=libntp_source + libntp_source_sharable,
        target="ntp",
        use="SSL CRYPTO",
    )

    # Loadable Python extension
    ctx(
        features="c cshlib pyext",
        install_path='${PYTHONARCHDIR}/ntp',
        includes=[ctx.bldnode.parent.abspath(), "../include"],
        source=["pymodule.c"] + libntp_source_sharable,
        target="../pylib/ntpc",  # Put the output in the pylib directory
        use="M RT CRYPTO",
    )

=== ntptime/wscript ===
def build(ctx):
    if ctx.env.HEADER_SYS_TIMEX_H:
        ctx(
            target="ntptime",
            features="c cprogram",
            includes=[ctx.bldnode.parent.abspath(), "../include"],
            source=["ntptime.c"],
            use="ntp M RT",
            install_path='${BINDIR}',
        )

    ctx.manpage(8, "ntptime-man.adoc")

# end

=== pylib/wscript ===
from waflib.Logs import pprint


def options(opt):
    opt.load('python')


def configure(conf):
    conf.load('python')
    if not conf.env.ENABLE_CROSS:
        conf.check_python_version((2, 6, 0))
    conf.check_python_headers(features='pyext')  # Extension-only, no embedded
    try:
        conf.check_python_module('curses')
        conf.env['PYTHON_CURSES'] = True
    except conf.errors.ConfigurationError:
        pprint("YELLOW", "WARNING: ntpmon will not be built/installed since "
               "python curses module was not found")
    try:
        conf.check_python_module('argparse')
        conf.env['PYTHON_ARGPARSE'] = True
    except conf.errors.ConfigurationError:
        pprint("YELLOW", "WARNING: ntploggps, ntplogtemp, and ntpviz will not "
               "be built/installed since python argparse module was not found")
    try:
        conf.check_python_module('gps', condition="ver >= num(3, 18)")
        conf.env['PYTHON_GPS'] = True
    except conf.errors.ConfigurationError:
        pprint("YELLOW", "WARNING: ntploggps will not be built/installed since "
               "python gps module >= 3.18 was not found")


def build(ctx):
    srcnode = ctx.srcnode.make_node('pylib')
    bldnode = ctx.bldnode.make_node('pylib')
    target1 = bldnode.make_node('control.py')
    target2 = bldnode.make_node('magic.py')

    sources = srcnode.ant_glob('*.py')
    builds = [x.get_bld() for x in sources]

    # The rm's here were added to fix a reported (but underdocumented) problem
    # where the results of pythonize-header were not updated when needed,
    # though there is as yet no explanation for why this had occurred, and the
    # alleged failure only occurred when changing the code between 'configure'
    # and 'build', which is not a legal action, anyway.
    # These rm's were causing unnecessary reruns of pythonize-header,
    # including during 'install'. They are now disabled but retained as a
    # comment.

    ## Remove generated files to ensure they are properly updated
    #ctx.exec_command("rm -f %s" % target1.abspath())
    #ctx.exec_command("rm -f %s" % target2.abspath())

    # Make sure Python sees .py as well as .pyc/.pyo
    ctx(
        features="subst",
        source=sources,
        target=builds,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='${PYTHON} ${SRC} >${TGT}',
        source=["../wafhelpers/pythonize-header", "../include/ntp_control.h"],
        target=target1,
    )

    ctx(
        before=['pyc', 'pyo'],
        cwd=srcnode,
        rule='${PYTHON} ${SRC} >${TGT}',
        source=["../wafhelpers/pythonize-header", "../include/ntp.h"],
        target=target2,
    )

    # Force early creation of generated files
    ctx.add_group()

    ctx(
        features='py',
        source=builds+[target1, target2],
        install_from=bldnode,
        install_path='${PYTHONARCHDIR}/ntp'
    )

    # pep241  lay an egg
    egg = ['ntp-%s.egg-info' % ctx.env.NTPSEC_VERSION]
    ctx(
        features="subst",
        source=['ntp-in.egg-info'],
        target=egg
    )
    ctx.install_files(ctx.env.PYTHONARCHDIR, egg)

=== tests/wscript ===
import os
from waflib import Utils  # pylint: disable=import-error


def build(ctx):
    testsrc = ctx.srcnode.make_node('tests')
    pylib = ctx.srcnode.make_node('pylib')
    testpylib = testsrc.make_node('pylib')
    testpysrc = testpylib.ant_glob('*.py')

    # Unity source
    unity_source = [
        "unity/unity.c",
        "unity/unity_fixture.c",
    ]

    unity_config = ["UNITY_INCLUDE_DOUBLE", "UNITY_SUPPORT_64"]

    ctx(
        defines=unity_config,
        features="c",
        target="unity",
        source=unity_source
    )

    # Test main.
    common_source = [
        "common/tests_main.c",
        "common/caltime.c",
        "common/sockaddrtest.c",
    ]

    # libntp/
    libntp_source = [
        "libntp/authkeys.c",
        "libntp/ntp_calendar.c",
        "libntp/ntp_endian.c",
        "libntp/ntp_random.c",
        "libntp/clocktime.c",
        "libntp/decodenetnum.c",
        "libntp/dolfptoa.c",
        "libntp/hextolfp.c",
        "libntp/lfpfunc.c",
        "libntp/lfptostr.c",
        "libntp/macencrypt.c",
        "libntp/numtoa.c",
        "libntp/prettydate.c",
        "libntp/refidsmear.c",
        "libntp/socktoa.c",
        "libntp/statestr.c",
        "libntp/strtolfp.c",
        "libntp/timespecops.c",
        "libntp/vi64ops.c",
        "libntp/ymd2yd.c"
    ] + common_source

    ctx.ntp_test(
        features="c cprogram test",
        target="test_libntp",
        install_path=None,
        defines=unity_config + ["TEST_LIBNTP=1"],
        includes=[ctx.bldnode.parent.abspath(), "../include", "unity", "common"],
        use="unity ntp parse M PTHREAD CRYPTO RT SOCKET NSL",
        source=libntp_source,
    )

    if ctx.env.REFCLOCK_GENERIC or ctx.env.REFCLOCK_TRIMBLE:
        # libparse available/required wth generic and Trimble refclocks

        # libparse/
        libparse_source = [
            "libparse/binio.c",
            "libparse/gpstolfp.c",
            "libparse/ieee754io.c",
        ] + common_source

        ctx.ntp_test(
            defines=unity_config + ["TEST_LIBPARSE=1"],
            features="c cprogram test",
            includes=[ctx.bldnode.parent.abspath(), "../include", "unity"],
            install_path=None,
            lib=["parse"],
            libpath=["libparse"],
            source=libparse_source,
            target="test_libparse",
            use="unity ntp parse M PTHREAD RT SOCKET NSL",
        )

    ntpd_source = [
        # "ntpd/filegen.c",
        "ntpd/leapsec.c",
        "ntpd/restrict.c",
        "ntpd/recvbuff.c",
        "ntpd/nts.c",
        "ntpd/nts_client.c",
        "ntpd/nts_server.c",
        "ntpd/nts_cookie.c",
        "ntpd/nts_extens.c",
    ] + common_source

    ctx.ntp_test(
        defines=unity_config + ["TEST_NTPD=1"],
        features="c cprogram test",
        includes=[ctx.bldnode.parent.abspath(), "../include", "unity", "../ntpd", "common", "../libaes_siv"],
        install_path=None,
        source=ntpd_source,
        target="test_ntpd",
        use="ntpd_lib libntpd_obj unity ntp aes_siv "
            "M PTHREAD CRYPTO RT SOCKET NSL",
    )

    testpylib.get_bld().mkdir()

    pypath = pylib.get_bld()
    targdir = "tests/pylib"
    linkpath = ctx.bldnode.make_node(targdir + "/ntp").abspath()
    relpath = ("../" * (targdir.count("/")+1)) + pypath.path_from(ctx.bldnode)
    if (not os.path.exists(linkpath)) or os.readlink(linkpath) != relpath:
        try:
            os.remove(linkpath)
        except OSError:
            pass
        os.symlink(relpath, linkpath)

    pytests = ["pylib/test_util.py",
               "pylib/test_agentx.py",
               "pylib/test_agentx_packet.py",
               "pylib/test_packet.py",
               "pylib/test_statfiles.py"]

    ctx(
        features="subst",
        source=testpysrc,
        target=[x.get_bld() for x in testpysrc],
        chmod=Utils.O755,
    )

    for path in pytests:
        ctx(
            features="pytest",
            pytest_source=path,
            ut_str="${PYTHON} ${SRC}"
        )

=== debian/changelog ===
ntpsec (1.1.8+dfsg1-6~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
    - Revert: Switch to python3-gps
    - Revert: Drop as-needed linker flag

 -- Richard Laager <rlaager@wiktel.com>  Thu, 30 Apr 2020 00:19:47 -0500

ntpsec (1.1.8+dfsg1-6) unstable; urgency=high

  * Handle unset variable in certbot script
  * Update Standards-Version to 4.5.0 (no changes)

 -- Richard Laager <rlaager@wiktel.com>  Sat, 25 Apr 2020 22:17:18 -0500

ntpsec (1.1.8+dfsg1-5) unstable; urgency=high

  * Update debian/ntpsec-doc.doc-base
  * Remove copyright years
    https://blog.ntpsec.org/2020/02/15/copyright-year.html
  * Rename ntp-wait.service to ntpsec-wait.service
    This fixes a regression that occurred in 1.1.7+dfsg1-1.
  * Improve integration with systemd-cron
  * Update NTS label
    This is a backwards-incompatible change!
  * Update README.Debian notes about TLS 1.3
  * Rework certbot integration
  * Change from /usr/lib/ntp to /usr/libexec/ntpsec
  * Drop as-needed linker flag

 -- Richard Laager <rlaager@wiktel.com>  Sat, 25 Apr 2020 14:06:47 -0500

ntpsec (1.1.8+dfsg1-3~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Update gbp.conf for buster-backports
  * Update salsa-ci.yml for buster-backports

 -- Richard Laager <rlaager@wiktel.com>  Thu, 12 Dec 2019 00:14:30 -0600

=== debian/control ===
Source: ntpsec
Section: net
Priority: optional
Maintainer: Richard Laager <rlaager@wiktel.com>
Uploaders: tony mancill <tmancill@debian.org>,
Build-Depends: asciidoc,
               bison,
               debhelper-compat (= 12),
               dh-apache2,
               dh-apparmor,
               dh-python,
               docbook-xsl,
               libcap2-dev [linux-any],
               libssl-dev (>= 1.1.1),
               netbase,
               pkg-config,
               pps-tools [linux-any],
               python3 (>= 3.3),
               python3-dev (>= 3.3),
               systemd,
               xsltproc,
               xz-utils,
Build-Conflicts: libavahi-compat-libdnssd-dev,
                 libwww-dev,
                 libwww-ssl-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/ntpsec
Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
Homepage: https://www.ntpsec.org

Package: ntpsec
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         lsb-base (>= 3.2-13),
         netbase,
         python3 (>= 3.3),
         python3-ntp (= ${binary:Version}),
         tzdata (>= 2015d-1),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: systemd | cron | cron-daemon,
Suggests: apparmor,
          certbot,
          ntpsec-doc,
          ntpsec-ntpviz,
Breaks: apparmor-profiles-extra (<< 1.8),
Conflicts: ntp,
           ntpdate,
           time-daemon,
Provides: time-daemon,
Replaces: ntp,
          time-daemon,
Description: Network Time Protocol daemon and utility programs
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the NTP daemon and utility programs.  An NTP
 daemon needs to be running on each host that is to have its clock
 accuracy controlled by NTP.  The same NTP daemon is also used to
 provide NTP service to other hosts.
 .
 This is the NTPsec version of NTP.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 For more information about the NTP protocol and NTP server
 configuration and operation, install the package "ntpsec-doc".

Package: ntpsec-ntpdate
Architecture: any
Depends: netbase,
         python3 (>= 3.3),
         python3-ntp (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Conflicts: ntpdate,
Replaces: ntpdate,
Description: client for setting system time from NTP servers
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdate is a simple NTP client that sets a system's clock to match
 the time obtained by communicating with one or more NTP servers.  It
 is not sufficient, however, for maintaining an accurate clock in the
 long run.  ntpdate by itself is useful for occasionally setting the
 time on machines that do not have full-time network access, such as
 laptops.
 .
 This is the NTPsec version of ntpdate.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 If the full NTP daemon from the package "ntpsec" is installed, then
 ntpsec-ntpdate is not necessary.

Package: ntpsec-ntpviz
Architecture: any
Depends: adduser,
         fonts-liberation,
         gnuplot,
         python3 (>= 3.3),
         python3-ntp (= ${binary:Version}),
         systemd | cron | cron-daemon,
         ${misc:Depends},
Recommends: ntpsec,
            systemd | python3-psutil,
            ${misc:Recommends},
Suggests: python,
          python-gps,
Description: NTP statistics graphing utility
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpviz analyzes NTP log files and generates statistical plots from
 them.  The output is in the form of HTML with images.  If Apache is
 installed, it will be served at: /ntpviz
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntpsec-doc
Architecture: all
Depends: ${misc:Depends},
Section: doc
Multi-Arch: foreign
Description: Network Time Protocol documentation
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains HTML documentation for the ntpsec packages (ntpsec,
 ntpsec-ntpdate).
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: python3-ntp
Architecture: any
Depends: python3 (>= 3.3),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Provides: ${python3:Provides},
Section: python
Description: Python 3 NTP Helper Classes
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the Python "ntp" module, which contains helper
 classes for NTP utilities written in Python.
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with apache2,python3

override_dh_auto_configure:
ifeq (hurd, $(DEB_HOST_ARCH_OS))
	# hurd does not provided the system calls needed for ntpd to work.
	exit 1
endif
	# Only build with refclocks NOT slated for removal.  See also
	# debian/patches/update-refclock-docs.patch.  However, if the reason
	# for deprecation is only "two digit years", I *am* keeping it.
	#
	# Upstream references:
	# https://www.ntpsec.org/removal-plan.html
	# https://www.ntpsec.org/drivers.html
	#
	# Also drop modem.  It "requires a Hayes-compatible 1200bps modem,
	# hardware now 20 years obsolete".
	#
	# gpsd is a tough call.  It's not deprecated upstream, and it still can
	# work.  However, upstream recommends the use of SHM, as does every
	# example HOWTO I found with a quick search.  Furthermore, it is buggy:
	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002392.html
	# Also, it "makes all sorts of non-standard assumptions about how gpsd
	# is configured.  A configuration that is contorted and non-obvious":
	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002422.html
	# Most importantly, it is an attractive nuisance.  If someone is told
	# that the best practice is to use "gpsd", they might logically think
	# they should use the gpsd driver.
	#
	# We pass LDFLAGS as LINKFLAGS because LINKFLAGS appears first in the
	# command line.  Debian wants to build with -fPIE for security reasons.
	# This is not compatible with building shared libraries like the ntpc
	# python extension.  If the -fPIE flag comes before -shared (or -fPIC),
	# the latter will override, and the build succeeds.
	CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
	LDFLAGS='' \
	LINKFLAGS='$(LDFLAGS)' \
		python3 waf configure \
		--prefix=/usr --enable-debug --enable-debug-gdb \
		--enable-mssntp --enable-warnings \
		--refclock=local,spectracom,generic,arbiter,nmea,pps,hpgps,shm,trimble,jjy,zyfer \
		--enable-doc --htmldir=/usr/share/doc/ntpsec/html \
		--build-epoch=$(SOURCE_DATE_EPOCH) \

override_dh_auto_build:
	python3 waf build -v

override_dh_auto_clean:
	python3 waf clean || true
	rm -rf \
		build \
		.lock-waf_*_build \
		ntpclients/ntp \
		ntpd/version.h \
		pylib/control.py \
		pylib/magic.py \
		pylib/version.py \
		.waf* \
		wafhelpers/autorevision.sh
	find -name "*.pyc" -delete

override_dh_install:
	python3 waf install --destdir=$(CURDIR)/debian/tmp
	mv \
		debian/tmp/lib/systemd/system/ntpd.service \
		debian/tmp/lib/systemd/system/ntpsec.service
	mv \
		debian/tmp/lib/systemd/system/ntp-wait.service \
		debian/tmp/lib/systemd/system/ntpsec-wait.service
	rm -rf debian/tmp/usr/lib/python3/dist-packages/ntp/__pycache__
	# This is not a pic, but really exists as a comment.
	rm debian/tmp/usr/share/doc/ntpsec/html/pic/panda.adoc
	# ntpfrob probes internal, mostly undocumented settings.  It is
	# extremely unlikely that anyone needs this.
	#
	# ntpsnmpd is experimental.  If support for it is desired, then
	# it can be installed, but it will require some patching of file
	# paths to be compliant with Debian best practices.  It also needs
	# more documentation on how to integrate with snmpd.
	#
	# From ntpsweep.1, "ntpsweep relies on ntpq and Mode 6 queries to
	# probe servers. This depends on the remote host's restrict
	# configuration allowing queries. Nowadays effectively all public
	# hosts set noquery, so this script is unlikely to be useful unless
	# you have multiple specially-configured timeservers on a LAN."  The
	# default ntp.conf from this package also sets "noquery" (with an
	# exception for localhost).
	rm \
		debian/tmp/usr/bin/ntpfrob \
		debian/tmp/usr/bin/ntpsnmpd \
		debian/tmp/usr/bin/ntpsweep \
		debian/tmp/usr/share/man/man1/ntpsweep.1 \
		debian/tmp/usr/share/man/man8/ntpfrob.8 \
	        debian/tmp/usr/share/man/man8/ntpsnmpd.8
	mv \
		debian/tmp/usr/bin/ntptime \
		debian/tmp/usr/bin/ntpkeygen \
		debian/tmp/usr/bin/ntploggps \
		debian/tmp/usr/bin/ntplogtemp \
		debian/tmp/usr/bin/ntpwait \
		debian/tmp/usr/sbin/
	install -m 755 \
		attic/ntpdate \
		debian/tmp/usr/sbin

	install -d debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy
	install -m 755 \
		debian/ntpsec.certbot \
		debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy/ntpsec

	install -d debian/ntpsec/lib/systemd/system
	install -m 644 \
		debian/ntpsec.ntpsec-rotate-stats.service \
		debian/ntpsec/lib/systemd/system/ntpsec-rotate-stats.service
	install -m 644 \
		debian/ntpsec.ntpsec-rotate-stats.timer \
		debian/ntpsec/lib/systemd/system/ntpsec-rotate-stats.timer

	install -d debian/ntpsec-ntpviz/lib/systemd/system
	install -m 644 \
		etc/ntploggps.service \
		etc/ntploggps.timer \
		debian/ntpsec-ntpviz/lib/systemd/system/

	install -d debian/ntpsec-ntpviz/etc/ntpviz/day
	install -m 644 www/day/footer \
		debian/ntpsec-ntpviz/etc/ntpviz/day/footer.html
	install -m 644 www/day/header \
		debian/ntpsec-ntpviz/etc/ntpviz/day/header.html
	install -m 644 www/index.html \
		debian/ntpsec-ntpviz/etc/ntpviz/index.html
	install -m 644 debian/ntpviz.options \
		debian/ntpsec-ntpviz/etc/ntpviz/options
	install -d debian/ntpsec-ntpviz/etc/ntpviz/week
	install -m 644 www/week/footer \
		debian/ntpsec-ntpviz/etc/ntpviz/week/footer.html
	install -m 644 www/week/header \
		debian/ntpsec-ntpviz/etc/ntpviz/week/header.html

	install -d debian/ntpsec-ntpviz/usr/share/ntpsec-ntpviz/ntpviz
	install -m 644 \
		www/favicon.ico \
		www/ntpsec-logo.png \
		debian/ntpsec-ntpviz/usr/share/ntpsec-ntpviz/ntpviz

	install -D -m 0755 debian/ntpdate-debian \
		debian/ntpsec-ntpdate/usr/sbin/ntpdate-debian
	install -D -m 0644 debian/ntpsec.dhcp \
		debian/ntpsec/etc/dhcp/dhclient-exit-hooks.d/ntpsec
	install -D -m 0755 debian/ntpsec.networkmanager \
		debian/ntpsec/etc/NetworkManager/dispatcher.d/ntpsec
	install -D -m 0644 debian/ntpsec-ntpdate.dhcp \
		debian/ntpsec-ntpdate/etc/dhcp/dhclient-exit-hooks.d/ntpsec-ntpdate
	install -D -m 0755 debian/ntpsec-ntpdate.networkmanager \
		debian/ntpsec-ntpdate/etc/NetworkManager/dispatcher.d/ntpsec-ntpdate
	install -D -m 0644 debian/ntpsec-systemd-netif.path \
		debian/ntpsec/lib/systemd/system/ntpsec-systemd-netif.path
	install -D -m 0644 debian/ntpsec-systemd-netif.service \
		debian/ntpsec/lib/systemd/system/ntpsec-systemd-netif.service

ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
	install -D -m 0644 debian/ntp.conf.ubuntu debian/ntpsec/etc/ntpsec/ntp.conf
else
	install -D -m 0644 debian/ntp.conf debian/ntpsec/etc/ntpsec/ntp.conf
endif
	install -D -m 0644 debian/ntpviz.conf \
		debian/ntpsec-ntpviz/etc/ntpsec/ntp.d/ntpviz.conf

	# install apparmor profile
	install -D -m 0644 debian/apparmor-profile \
		debian/ntpsec/etc/apparmor.d/usr.sbin.ntpd
	install -D -m 0644 debian/apparmor-profile.tunable \
		debian/ntpsec/etc/apparmor.d/tunables/ntpd
	dh_link -pntpsec etc/apparmor.d/usr.sbin.ntpd \
		etc/apparmor/init/network-interface-security/usr.sbin.ntpd

	# install apport hook
	install -D -m 644 debian/source_ntpsec.py \
		debian/ntpsec/usr/share/apport/package-hooks/source_ntpsec.py

	dh_link
	dh_install

override_dh_installinit-arch:
	dh_installinit -pntpsec --error-handler=installinit_error
	dh_installinit -pntpsec-ntpviz --name=ntpviz
	dh_installinit -pntpsec-ntpdate
ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
	install -m 644 debian/ntpsec-ntpdate.default.ubuntu \
		debian/ntpsec-ntpdate/etc/default/ntpsec-ntpdate
endif
	dh_apparmor --profile-name=usr.sbin.ntpd -pntpsec

override_dh_installsystemd:
	dh_installsystemd -pntpsec \
		ntpsec.service \
		ntpsec-systemd-netif.path \
		ntpsec-rotate-stats.timer
	dh_installsystemd -pntpsec-ntpviz \
		ntploggps.timer \
		ntplogtemp.timer \
		ntpviz-daily.timer \
		ntpviz-weekly.timer

## ntpsec 1.1.9+dfsg1

=== wscript ===
--- 
+++ 
@@ -55,10 +55,12 @@
 
 def options(ctx):
     options_cmd(ctx, config)
+    ctx.load('asciidoc', tooldir='wafhelpers/')
     ctx.recurse("pylib")
 
 
 def configure(ctx):
+    ctx.load('asciidoc', tooldir='wafhelpers/')
     class oc(Build.BuildContext):
         cmd = 'oc'
 
@@ -93,7 +95,6 @@
     ctx.run_build_cls = 'check'
     ctx.load('waf', tooldir='wafhelpers/')
     ctx.load('waf_unit_test')
-    ctx.load('pytest')
     ctx.load('gnu_dirs')
 
     with open("VERSION", "r") as f:
@@ -147,55 +148,6 @@
     # Not needed to build.  Used by utility scripts.
     ctx.find_program("awk", var="BIN_AWK", mandatory=False)
     ctx.find_program("sh", var="BIN_SH", mandatory=False)
-
-    # used to make man and html pages
-    ctx.find_program("asciidoc", var="BIN_ASCIIDOC", mandatory=False)
-    # make sure asciidoc is new enough.
-    # based on check_python_version() from waf
-    if ctx.env.BIN_ASCIIDOC:
-        # https://lists.ntpsec.org/pipermail/devel/2016-July/001778.html
-        asciidocminver = (8, 6, 0)
-        # Get asciidoc version string
-        cmd = ctx.env.BIN_ASCIIDOC + ['--version']
-        # example output: asciidoc 8.6.9
-        lines = ctx.cmd_and_log(cmd).split()[1].split(".")
-        assert len(lines) == 3, "found %r lines, expected 3: %r" \
-            % (len(lines), lines)
-        asciidocver_tuple = (int(lines[0]), int(lines[1]), int(lines[2]))
-
-        # Compare asciidoc version with the minimum required
-        result = (asciidocver_tuple >= asciidocminver)
-
-        asciidocver_full = '.'.join(map(str, asciidocver_tuple[:3]))
-        asciidocminver_str = '.'.join(map(str, asciidocminver))
-        ctx.msg('Checking for asciidoc version >= %s' % (asciidocminver_str,),
-                asciidocver_full, color=result and 'GREEN' or 'YELLOW')
-
-        if not result:
-            del ctx.env.BIN_ASCIIDOC
-    ctx.find_program("a2x", var="BIN_A2X", mandatory=False)
-    ctx.find_program("xsltproc", var="BIN_XSLTPROC", mandatory=False)
-
-    ctx.env.ENABLE_DOC = False
-    if ctx.env.BIN_ASCIIDOC and ctx.env.BIN_XSLTPROC and ctx.env.BIN_A2X:
-        ctx.env.ENABLE_DOC = True
-
-    if ctx.options.enable_doc and not ctx.env.ENABLE_DOC:
-        ctx.fatal("asciidoc and xsltproc are required in order "
-                  "to build documentation")
-    elif ctx.options.enable_doc:
-        ctx.env.ASCIIDOC_FLAGS = []
-        ctx.env.ENABLE_DOC_USER = ctx.options.enable_doc
-
-    # XXX: conditionally build this with --disable-man?
-    # Should it build without docs enabled?
-    ctx.env.A2X_FLAGS = ["--format", "manpage"]
-    if not ctx.options.enable_a2x_xmllint:
-        ctx.env.A2X_FLAGS += ["--no-xmllint"]
-
-    # Disable manpages within build()
-    if ctx.options.disable_manpage:
-        ctx.env.DISABLE_MANPAGE = True
 
     ctx.check_cfg(
         package='systemd', variables=['systemdsystemunitdir'],
@@ -330,3 +282,50 @@
         ('PIE', '-pie -fPIE'),
         # this quiets most of macOS warnings on -fpie
         ('unused', '-Qunused-arguments'),
+        # This is a useless warning on any architecture with a barrel
+        # shifter, which includes Intel and ARM and basically
+        # everything nowadays. Even so, we'd enable it out of
+        # perfectionism, but the GCC directives that ought to be
+        # useful for forcing structure alignment in order to suppress
+        # it locally don't seem to be working quite right.
+        #('w_cast_align', "-Wcast-align"),
+        ('w_cast_qual', "-Wcast-qual"),
+        ('w_disabled_optimization', "-Wdisabled-optimization"),
+        ('w_float_equal', "-Wfloat-equal"),
+        ('w_format', '-Wformat'),
+        ('w_format_security', '-Wformat-security'),
+        # fails on OpenBSD 6
+        ('w_format_signedness', '-Wformat-signedness'),
+        ('w_implicit_function_declaration', "-Wimplicit-function-declaration"),
+        ('w_init_self', '-Winit-self'),
+        ('w_invalid_pch', '-Winvalid-pch'),
+        ('w_missing_declarations', '-Wmissing-declarations'),
+        ('w_multichar', '-Wmultichar'),
+        ('w_packed', '-Wpacked'),
+        ('w_pointer_arith', '-Wpointer-arith'),
+        ('w_shadow', '-Wshadow'),
+        # fails on clang
+        ('w_suggest_attribute_noreturn', "-Wsuggest-attribute=noreturn"),
+        ('w_write_strings', '-Wwrite-strings'),
+        ]
+
+    # Check which linker flags are supported
+    ld_hardening_flags = [
+        ("z_now", "-Wl,-z,now"),     # no deferred symbol resolution
+    ]
+
+    # we prepend our options to CFLAGS, this allows user provided
+    # CFLAGS to override our computed CFLAGS
+    if ctx.options.enable_debug_gdb:
+        ctx.env.CFLAGS = ["-g"] + ctx.env.CFLAGS
+        ctx.define("USEBACKTRACE", "1", quote=False)
+    else:
+        # not gdb debugging
+        cc_test_flags += [
+            ('LTO', '-flto'),                   # link time optimization
+            ]
+        ld_hardening_flags += [
+            ('stripall', "-Wl,--strip-all"),    # Strip binaries
+            ]
+
+    if ctx.options.enable_debug:

=== attic/wscript ===
--- 
+++ 
@@ -1,5 +1,7 @@
 def build(ctx):
-    util = ['sht', 'digest-find', 'digest-timing', 'clocks', 'backwards']
+    util = [	'sht',
+		'digest-find', 'digest-timing', 'clocks', "random",
+		'backwards']
 
     for name in util:
         ctx(

=== libntp/wscript ===
--- 
+++ 
@@ -44,7 +44,7 @@
         includes=[ctx.bldnode.parent.abspath(), "../include"],
         source=libntp_source + libntp_source_sharable,
         target="ntp",
-        use="SSL CRYPTO",
+        use="CRYPTO SSL",
     )
 
     # Loadable Python extension

=== debian/changelog ===
ntpsec (1.1.9+dfsg1-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
    - Revert: Switch to python3-gps
    - Revert: Drop as-needed linker flag
    - Revert: Drop ntpsec-ntpviz Suggests python
    - Revert: Switch to asciidoctor

 -- Richard Laager <rlaager@debian.org>  Sun, 23 Aug 2020 16:44:08 -0500

ntpsec (1.1.9+dfsg1-2) unstable; urgency=medium

  * Fix bogus port number in NTS-KE connecting message

 -- Richard Laager <rlaager@debian.org>  Sat, 15 Aug 2020 17:53:35 -0500

ntpsec (1.1.9+dfsg1-1) unstable; urgency=medium

  * New upstream version
    - Add AES and other algorithm support to ntpq and ntpdig, from OpenSSL.
    - The default restrictions now start with noquery and limited to reduce
      the opportunities for being used for DDoS-ing.
    - NTS (per the draft RFC) now requires TLS 1.3.
      - The config keyword tlsciphers has been removed.
    - Additional filtering and sort options have been added to ntpq/mrulist.
    - With "restrict limited", traffic is now limited to an average of 1
      packet per second with bursts of 20.
    - SIGHUP and hourly checks have been unified.  Both now:
        - check for a new log file
        - check for a new certificate file
        - check for a new leap file
      SIGHUP also restarts all pending DNS and NTS probes.
    - Defer loading certificate until after drop-root.  This checks that file
      permissions are setup correctly so ntpd will be able to reload the
      certificate.
    - Fix ntpleapfetch to work with latest leap file.
    - This fixes building with GCC 10. (Closes: 957616)
  * Drop ntpsec-ntpviz Suggests python
  * Fix the certbot hook quoting
  * Switch to rlaager@debian.org
  * Switch to asciidoctor
  * Raise OpenSSL dependency
  * Start transition to port 4460
    - ntpd in server mode now listens on both ports 123 and 4460.
    - ntpd in client mode now defaults to port 4460.
  * Upgrade to debhelper-compat 13

 -- Richard Laager <rlaager@debian.org>  Thu, 13 Aug 2020 02:11:44 -0500

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,16 @@
 Source: ntpsec
 Section: net
 Priority: optional
-Maintainer: Richard Laager <rlaager@wiktel.com>
-Uploaders: tony mancill <tmancill@debian.org>,
+Maintainer: Richard Laager <rlaager@debian.org>
 Build-Depends: asciidoc,
                bison,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                dh-apache2,
                dh-apparmor,
                dh-python,
                docbook-xsl,
                libcap2-dev [linux-any],
-               libssl-dev (>= 1.1.1),
+               libssl-dev (>= 1.1.1b),
                netbase,
                pkg-config,
                pps-tools [linux-any],

=== debian/rules ===
--- 
+++ 
@@ -78,8 +78,6 @@
 		debian/tmp/lib/systemd/system/ntp-wait.service \
 		debian/tmp/lib/systemd/system/ntpsec-wait.service
 	rm -rf debian/tmp/usr/lib/python3/dist-packages/ntp/__pycache__
-	# This is not a pic, but really exists as a comment.
-	rm debian/tmp/usr/share/doc/ntpsec/html/pic/panda.adoc
 	# ntpfrob probes internal, mostly undocumented settings.  It is
 	# extremely unlikely that anyone needs this.
 	#
